<html>
<head>
	<title>Swarm Bots</title>
	<link rel="stylesheet" type="text/css" href="../styles.css"/>
</head>
<body>
<div id="content">
	<h2>Swarm Bots</h2>
	<h3>Agent Algorithm</h3>
	<p>
		A swarm agent looks at all the other agents he can see and
		selects the closest ones to follow. He then averages the velocities
		of his selected neighbors and accelerates in that direction, with
		a little bit of randomness added.
	</p>
	<h4>Pseudocode</h4>
	<div class="pseudocode">
<pre>neighborsToFollow = selectNeighbors(visibleAgents)
adjustedAverageVelocity = averageVelocities(neighborsToFollow) *
                         (1 - randomizationFactor)
randomization = random direction * randomizationFactor
acceleration = adjustedAverageVelocity + randomization</pre>
	</div>
	<h3>Observed Behavior</h3>
	<p>
		This really is the simplest algorithm that will produce
		"life-like" behavior. The agents move around in swarms, at least
		until a wall stops them. The sliders vary the behavior in many
		different ways.
	</p>
	<p>
		Unchecking "Choose Neighbors by Proximity" will change the
		algorithm to select random neighbors to follow.
	</p>
	<h3>The Applet</h3>
	<applet archive="../dist/appletbots.jar"
	        code="appletbots.swarm.SwarmApplet"
	        alt="Swarm Applet"
	        width="600"
	        height="480">
		<div>
			If you see this, you need to either enable java, or install the Sun Java
			Virtual Machine in your browser. To do so,
			<a href="http://java.sun.com/getjava/download.html">click here</a>.
		</div>
	</applet>
  <h3>Source Code</h3>
  <ul>
    <li>
      <a href="http://repo.or.cz/w/applet-bots.git?a=blob;f=src/appletbots/swarm/SwarmApplet.java">SwarmApplet.java</a>
    </li>
    <li>
      <a href="http://repo.or.cz/w/applet-bots.git?a=blob;f=src/appletbots/swarm/SwarmAgent.java">SwarmAgent.java</a>
    </li>
  </ul>
	<a href="../" class="return">Back to the Applet Bots Home</a>
</div>
<div class="official">
	The official version of this file is at <a href="http://applet-bots.sourceforge.net/applets/swarm.html">applet-bots.sourceforge.net</a>
	<a href="http://sourceforge.net" class="sf-logo"><img border="0" alt="SourceForge.net Logo" src="http://sflogo.sourceforge.net/sflogo.php?group_id=205988&amp;type=1"/></a>
</div>
</body>
</html>
